#include <ultra64.h>
#include "sm64.h"
#include "behavior_data.h"
#include "model_ids.h"
#include "seq_ids.h"
#include "dialog_ids.h"
#include "segment_symbols.h"
#include "level_commands.h"

#include "game/level_update.h"

#include "levels/scripts.h"

#include "make_const_nonconst.h"
#include "levels/arena_blockfort/header.h"

/* Fast64 begin persistent block [scripts] */
/* Fast64 end persistent block [scripts] */

const LevelScript level_arena_blockfort_entry[] = {
	INIT_LEVEL(),
	LOAD_MIO0(0x7, _arena_blockfort_segment_7SegmentRomStart, _arena_blockfort_segment_7SegmentRomEnd), 
	LOAD_MIO0(0xa, _water_skybox_mio0SegmentRomStart, _water_skybox_mio0SegmentRomEnd), 
	ALLOC_LEVEL_POOL(),
	MARIO(MODEL_MARIO, 0x00000001, bhvMario),
	/* Fast64 begin persistent block [level commands] */
	/* Fast64 end persistent block [level commands] */

	AREA(1, arena_blockfort_area_1),
		WARP_NODE(0x0A, LEVEL_BOB, 0x01, 0x0A, WARP_NO_CHECKPOINT),
		WARP_NODE(0xF0, LEVEL_CASTLE, 0x01, 0x32, WARP_NO_CHECKPOINT),
		WARP_NODE(0xF1, LEVEL_CASTLE, 0x01, 0x64, WARP_NO_CHECKPOINT),
		OBJECT(MODEL_NONE, 3331, 5152, -3295, 0, -41, 0, (0x02 << 24), id_bhvArenaSpawn),
		OBJECT(MODEL_NONE, 3921, 5152, -3255, 0, -41, 0, (0x02 << 24), id_bhvArenaSpawn),
		OBJECT(MODEL_NONE, 4486, 5152, -3239, 0, -41, 0, (0x02 << 24), id_bhvArenaSpawn),
		OBJECT(MODEL_NONE, 3220, 5152, -3781, 0, -41, 0, (0x02 << 24), id_bhvArenaSpawn),
		OBJECT(MODEL_NONE, 3212, 5152, -4426, 0, -41, 0, (0x02 << 24), id_bhvArenaSpawn),
		OBJECT(MODEL_NONE, 4182, 5053, -4192, 180, 0, 0, (0x02 << 24), id_bhvArenaFlag),
		OBJECT(MODEL_NONE, -4746, 5004, 4621, 0, 0, 0, (0x05 << 24), id_bhvArenaItem),
		OBJECT(MODEL_NONE, 4808, 5004, -4815, 0, 0, 0, (0x05 << 24), id_bhvArenaItem),
		OBJECT(MODEL_NONE, 1166, 4603, -1161, 0, 0, 0, (0x05 << 24), id_bhvArenaItem),
		OBJECT(MODEL_NONE, -1165, 4573, 1135, 0, 0, 0, (0x05 << 24), id_bhvArenaItem),
		OBJECT(MODEL_NONE, -6980, 3617, -6971, 0, 0, 0, (0x05 << 24), id_bhvArenaItem),
		OBJECT(MODEL_NONE, 7155, 3617, 6776, 0, 0, 0, (0x05 << 24), id_bhvArenaItem),
		OBJECT(MODEL_NONE, 2498, 4888, 2588, 0, 0, 0, (0x04 << 24), id_bhvArenaItem),
		OBJECT(MODEL_NONE, -4780, 3608, -4681, 0, 0, 0, (0x04 << 24), id_bhvArenaItem),
		OBJECT(MODEL_NONE, 2118, 3605, -5633, 0, 0, 0, (0x04 << 24), id_bhvArenaItem),
		OBJECT(MODEL_NONE, -4828, 5261, -4704, 0, 0, 0, (0x03 << 24), id_bhvArenaItem),
		OBJECT(MODEL_NONE, 4901, 3583, 2848, 0, 0, 0, (0x03 << 24), id_bhvArenaItem),
		OBJECT(MODEL_NONE, -2002, 3578, 5905, 0, 0, 0, (0x03 << 24), id_bhvArenaItem),
		OBJECT(MODEL_NONE, 1157, 4646, 1134, 0, 0, 0, (0x02 << 24), id_bhvArenaItem),
		OBJECT(MODEL_NONE, -1141, 4646, -1142, 0, 0, 0, (0x02 << 24), id_bhvArenaItem),
		OBJECT(MODEL_NONE, 1672, 4403, -5931, 0, 0, 0, (0x02 << 24), id_bhvArenaItem),
		OBJECT(MODEL_NONE, -1703, 4403, 6029, 0, 0, 0, (0x02 << 24), id_bhvArenaItem),
		OBJECT(MODEL_NONE, -6752, 3690, 7025, 0, 0, 0, (0x02 << 24), id_bhvArenaItem),
		OBJECT(MODEL_NONE, 6938, 3690, -6934, 0, 0, 0, (0x02 << 24), id_bhvArenaItem),
		OBJECT(MODEL_NONE, 1, 4738, 1, 0, 0, 0, 0x00000000, id_bhvArenaKoth),
		OBJECT(MODEL_NONE, 0, 4739, 1, 0, 0, 0, 0x00000000, id_bhvArenaKoth),
		OBJECT(MODEL_NONE, 0, 5280, 0, 0, 180, 0, 0x000A0000, bhvInstantActiveWarp),
		MARIO_POS(0x01, 180, 0, 5280, 0),
		OBJECT(MODEL_NONE, 1, 3946, 0, 0, 0, 0, (0x01 << 24), id_bhvArenaItem),
		OBJECT(MODEL_NONE, 2, 3669, -7273, 0, 0, 0, (0x06 << 24), id_bhvArenaItem),
		OBJECT(MODEL_NONE, 7365, 3669, -24, 0, 0, 0, (0x06 << 24), id_bhvArenaItem),
		OBJECT(MODEL_NONE, -7275, 3669, -24, 0, 0, 0, (0x06 << 24), id_bhvArenaItem),
		OBJECT(MODEL_NONE, -55, 3669, 7253, 0, 0, 0, (0x06 << 24), id_bhvArenaItem),
		OBJECT(MODEL_NONE, 2, 5001, -4886, 0, 0, 0, (0x06 << 24), id_bhvArenaItem),
		OBJECT(MODEL_NONE, 4867, 5001, -23, 0, 0, 0, (0x06 << 24), id_bhvArenaItem),
		OBJECT(MODEL_NONE, 13, 5001, 4649, 0, 0, 0, (0x06 << 24), id_bhvArenaItem),
		OBJECT(MODEL_NONE, -4771, 5001, -67, 0, 0, 0, (0x06 << 24), id_bhvArenaItem),
		OBJECT(MODEL_NONE, -3349, 5166, 3187, 0, 132, 0, (0x01 << 24), id_bhvArenaSpawn),
		OBJECT(MODEL_NONE, -3212, 5166, 3626, 0, 132, 0, (0x01 << 24), id_bhvArenaSpawn),
		OBJECT(MODEL_NONE, -3229, 5166, 4145, 0, 132, 0, (0x01 << 24), id_bhvArenaSpawn),
		OBJECT(MODEL_NONE, -3794, 5166, 3039, 0, 132, 0, (0x01 << 24), id_bhvArenaSpawn),
		OBJECT(MODEL_NONE, -4262, 5166, 3026, 0, 132, 0, (0x01 << 24), id_bhvArenaSpawn),
		OBJECT(MODEL_NONE, -4173, 4971, 3972, 0, 180, 0, (0x01 << 24), id_bhvArenaFlag),
		OBJECT(MODEL_NONE, -5274, 4241, 5223, 0, 0, 0, (99), id_bhvArenaSpring),
		OBJECT(MODEL_NONE, 5302, 4239, -5348, 0, 0, 0, (99), id_bhvArenaSpring),
		OBJECT(MODEL_NONE, -1, 5642, 1, 0, 0, 0, (10 << 16), bhvAirborneWarp),
		OBJECT(MODEL_NONE, 0, 3673, 0, 0, 0, 0, (0x00 << 24), id_bhvArenaFlag),
		TERRAIN(arena_blockfort_area_1_collision),
		MACRO_OBJECTS(arena_blockfort_area_1_macro_objs),
		SET_BACKGROUND_MUSIC(0x00, SEQ_LEVEL_GRASS),
		TERRAIN_TYPE(TERRAIN_GRASS),
		/* Fast64 begin persistent block [area commands] */
		/* Fast64 end persistent block [area commands] */
	END_AREA(),
	FREE_LEVEL_POOL(),
	MARIO_POS(0x01, 180, 0, 5280, 0),
	CALL(0, lvl_init_or_update),
	CALL_LOOP(1, lvl_init_or_update),
	CLEAR_LEVEL(),
	SLEEP_BEFORE_EXIT(1),
	EXIT(),
};